package it.macke.is;

import it.macke.is.services.NaturalErrorInfo;

import com.wm.data.IData;
import com.wm.data.IDataCursor;
import com.wm.data.IDataFactory;

public class FieldConverter
{
	public static Object convertToPipeline(String typeName, Object object)
	{
		IData result = IDataFactory.create();
		switch (typeName)
		{
			case "java.lang.String":
				return convertFromString(object);
			case "it.macke.is.services.NaturalErrorInfo":
				return convertFromNaturalErrorInfo((NaturalErrorInfo) object);
			default:
				System.out.println("Missing input converter for type <" + typeName + ">");
				break;
		}
		return result;
	}

	private static Object convertFromNaturalErrorInfo(NaturalErrorInfo object)
	{
		String errorFlag = "";
		String[] errorCodes = new String[] {};
		String[] errorMessages = new String[] {};
		if (object != null)
		{
			errorFlag = object.ERROR_FLAG;
			errorCodes = object.ERROR_CODES;
			errorMessages = object.ERROR_MESSAGES;
		}
		IData output = IDataFactory.create();
		IDataCursor idc = output.getCursor();
		idc.insertAfter("ERROR-FLAG", errorFlag);
		idc.insertAfter("ERROR-CODES", errorCodes);
		idc.insertAfter("ERROR-MESSAGES", errorMessages);
		idc.destroy();
		return output;
	}

	private static Object convertFromString(Object object)
	{
		if (object == null)
		{
			return null;
		}
		return object.toString();
	}

}
