package it.macke.is;

import it.macke.is.common.Error;
import it.macke.is.common.ErrorInfo;

import java.util.ArrayList;
import java.util.List;

import com.wm.data.IData;
import com.wm.data.IDataCursor;
import com.wm.data.IDataUtil;

public class PipelineConverter
{
	public static Object convertToField(String typeName, Object object)
	{
		switch (typeName)
		{
			case "java.lang.String":
				return convertToString(object);
			case "it.macke.is.common.ErrorInfo":
				return convertToErrorInfo((IData) object);
			default:
				System.out.println("Missing output converter for type <" + typeName + ">");
				return null;
		}
	}

	private static Object convertToErrorInfo(IData object)
	{
		ErrorInfo output = new ErrorInfo();
		String errorFlag = "";
		Error[] errors = new Error[] {};

		if (object != null)
		{
			IDataCursor idc = object.getCursor();
			errorFlag = (String) IDataUtil.get(idc, "errorFlag");
			IData[] errorsFromPipeline = IDataUtil.getIDataArray(idc, "errors");
			idc.destroy();

			List<Error> errorList = new ArrayList<Error>();
			for (int e = 0; e < errorsFromPipeline.length; e++)
			{
				IDataCursor errorCursor = errorsFromPipeline[e].getCursor();
				String errorCode = (String) IDataUtil.get(errorCursor, "errorCode");
				String errorMessage = (String) IDataUtil.get(errorCursor, "errorMessage");
				String errorSource = (String) IDataUtil.get(errorCursor, "errorSource");
				Error error = new Error();
				error.errorCode = errorCode;
				error.errorMessage = errorMessage;
				error.errorSource = errorSource;
				errorList.add(error);
			}
			errors = errorList.toArray(errors);
		}

		output.errorFlag = errorFlag;
		output.errors = errors;

		return output;
	}

	private static Object convertToString(Object object)
	{
		return object;
	}

}
